program main

  use params
  implicit none

  character(90) inf1, inf2, outf1

  integer, parameter :: vecsize = 3388         !Number of parameters in model

  integer np, npbig

  doubleprecision, allocatable :: negcoefs(:), coefout(:), coefstart(:), s0(:)
  integer, allocatable :: notest(:), expcoefs(:), poscoefs(:), fixedcoefs(:)


  doubleprecision c(3)

  integer i,j,k,l,n

  integer i1,i2,i3,i4,i5,i6

  integer status

  integer vmlGetMode

  integer nseeds


  nseeds = 8

  call RANDOM_SEED(SIZE=nseeds)
  rseedstart = (/ 665623, 486395, 851406, 549218, 688761, 112745, 729855,   4002, 756345, 710118, 810020, 690728, 462139, 332989, 563510, 484890 /)
  call RANDOM_SEED(PUT=rseedstart)

  call sgrnd(665623)


  call DRNUN(3,c)

  write(*,*) 'Analysis for product:', prodname

  call setvars

  nipts = maxinv+1

  c(1) = 7.8
  c(2) = 0.3
  c(3) = 0.9

  call createhhdata(pathname//prodname//'/hhbayesbig.dat')

  np = numprods + 5
  npbig = numprods + 7

  allocate(negcoefs(npbig), coefout(npbig), coefstart(npbig), s0(np))
  allocate(notest(npbig), expcoefs(npbig), poscoefs(npbig), fixedcoefs(npbig))

  ! coefficients:
  ! 1:numprods: product dummies (first one normalized to 0)
  ! numprods+1: consumption utility
  ! numprods+2: inventory linear term
  ! numprods+3: inventory quadratic
  ! numprods+4: price
  ! numprods+5: feature
  ! numprods+6: display
  ! numprods+7: carrying cost

  fixedcoefs(1) = 1
  fixedcoefs(2:numprods) = 0
  fixedcoefs(2) = 1
  fixedcoefs(7) = 1
  fixedcoefs(8) = 1
  fixedcoefs(9) = 1
  fixedcoefs(10) = 1
  fixedcoefs(11) = 1
  fixedcoefs(numprods+1) = 0
  fixedcoefs(numprods+2) = 1 !0
  fixedcoefs(numprods+3) = 1
  fixedcoefs(numprods+4) = 0
  fixedcoefs(numprods+5) = 1
  fixedcoefs(numprods+6) = 1
  fixedcoefs(numprods+7) = 1

  notest = 0
  notest(1) = 1
  notest(numprods+2) = 1


  poscoefs = 0

  negcoefs = 1.d0
  negcoefs((numprods+2):(numprods+3)) = -1.d0
  expcoefs = 1
  expcoefs(1:numprods) = 0
  expcoefs(numprods+5) = 0
  expcoefs(numprods+6) = 0
  expcoefs(numprods+7) = 0

  ! these numbers will depend on how many products we include
  ! since there are a lot of coefficients, we will read them in

  open(unit=1,file=pathname//prodname//'/brandests.txt')

  do i=1,numprods

     read(1,*) coefstart(i)

  enddo

  read(1,*) coefstart(numprods+4)
  coefstart(numprods+4) = log(coefstart(numprods+4)/100)
  read(1,*) coefstart(numprods+5)
  read(1,*) coefstart(numprods+6)
  close(unit=1,status='keep')
  coefstart(numprods+1) = log(0.69)
  coefstart(numprods+2) = log(1e-10)
  coefstart(numprods+3) = log(1e-4)
  coefstart(numprods+7) = -1.6

  s0 = 10.d0
  if(sctypes) then
     coefstart(numprods+2) = log(1e-10)
     coefstart(numprods+3) = log(1e-10)
     notest(numprods+2) = 1
     notest(numprods+3) = 1
  endif

  j=0
  do i=1,npbig
     if(notest(i) == 0) j=j+1
  enddo
  if(j .ne. np) then
     print*,"Error: sum of notest == 0 is not equal to np",j,np
     stop
  endif


  if(allfixed .eq. 1) fixedcoefs = 1

  call hbstruct(np,npbig,coefstart,fixedcoefs,notest,expcoefs,poscoefs,negcoefs,s0)


end program main












