rm(list=ls())

library(Rcpp)

createdata = FALSE  # set this to TRUE to load in the posterior draws used in constructing the indexes

dealpct = 0.1  # cutoff for defining a deal

set.seed(8342971)

nindexes = 4

estpath = "C:/Users/MattOsborne/Dropbox/price index paper/estimation data/tuna/"                   #parameter estimates and intermediate data
step1path = "C:/Users/MattOsborne/Dropbox/price index paper/step 1 output files/"                  #data from step 1
tablepath = "C:/Users/MattOsborne/Dropbox/price index paper/output tables and figures/"    #tables for paper
figpath = "C:/Users/MattOsborne/Dropbox/price index paper/output tables and figures/"      #figures for paper

#estpath = "C:/Users/matthew/Dropbox/price index paper/estimation data/tuna/"                   #parameter estimates and intermediate data
#step1path = "C:/Users/matthew/Dropbox/price index paper/step 1 output files/"                  #data from step 1
#tablepath = "C:/Users/matthew/Dropbox/price index paper/output tables and figures/"            #tables for paper
#figpath = "C:/Users/matthew/Dropbox/price index paper/output tables and figures/"              #figures for paper


load(paste(estpath,"tuna_finaldata.RData",sep=""))

hhall4$unitswk[is.na(hhall4$unitswk)] = 0

index.list = vector("list",length=nindexes)

compsave = vector("list",length=nindexes)
compsave2 = vector("list",length=nindexes)

laspeyres.big = vector("list",length=nindexes)
meanprice.big = vector("list",length=nindexes)
bestprice.big = vector("list",length=nindexes)

# price moments over time
worstprice.big = vector("list",length=nindexes) # this is store level

modeprice.big = vector("list",length=nindexes)
maxminspread.big = vector("list",length=nindexes)
var.big = vector("list",length=nindexes)
modeminspread.big = vector("list",length=nindexes)
meanminspread.big = vector("list",length=nindexes)

# these prices are constructed from the SAS regular/deal price data
regprice.big = vector("list",length=nindexes)
dealprice.big = vector("list",length=nindexes)
dealspread.big = vector("list",length=nindexes)
dealfreq.big = vector("list",length=nindexes)

upckeep = c(17800000120,17800000240,79100002450,79100002800,75450022620,77600152580)
nupc = length(upckeep)

endpd = 123

nstart = 5000
nend   = 25000
nskip  = 1
nvar = 12

# consumption utility - for rough calculations

consutil <- function(cons,i,coef) {

  return(coef[1]*log(cons+1) + coef[2]*i + coef[3]*i*i)

}

allweek = unique(hhall4$week)
allweek = allweek[order(allweek)]
minweek = 1
maxweek = length(allweek)
nweek = maxweek-minweek+1

storeids = unique(hhall4$storeid[hhall4$storeid>0])
storeids = storeids[order(storeids)]

if(createdata) {

  to.read = file(paste(estpath,"hb/alldraws_a.dat",sep=""),"rt")
  x=readLines(to.read)
  close(to.read)

  x = x[1:length(x)%%2==0]
  x1 = strsplit(x,"       ")
  x2 = as.double(unlist(x1))
  x3 = matrix(x2,nrow=nvar,ncol=length(x))
  asaves = t(x3[2:nvar,])

  to.read = file(paste(estpath,"hb/alldraws_d.dat",sep=""),"rt")
  x=readLines(to.read)
  close(to.read)

  x = x[1:length(x)%%2==0]
  x1 = strsplit(x,"       ")
  x2 = as.double(unlist(x1))
  x3 = matrix(x2,nrow=nvar,ncol=length(x))
  dsaves = t(x3[2:nvar,])

  to.read = file(paste(estpath,"hb/alldraws_u.dat",sep=""),"rt")
  x=readLines(to.read)
  close(to.read)

  x = x[1:length(x)%%2==0]
  x1 = strsplit(x," ")
  x3 = matrix(0,nrow=endpd,ncol=nend)
  for(i in 1:nend) {
    x1[[i]] = as.double(x1[[i]][x1[[i]] != ""])
    x3[,i] = x1[[i]]
    if(length(x1[[i]]) != endpd | sum(is.na(x1[[i]])) > 0 | typeof(x1[[i]]) != "double" ) {print(paste("check draw",i))}
  }
  usaves = t(x3)

  to.read = file(paste(estpath,"hb/alldraws_i.dat",sep=""),"rt")
  x=readLines(to.read)
  close(to.read)

  x = x[1:length(x)%%2==0]
  x1 = strsplit(x," ")
  x3 = matrix(0,nrow=endpd,ncol=nend)
  for(i in 1:nend) {
    x1[[i]] = as.double(x1[[i]][x1[[i]] != ""])
    x3[,i] = x1[[i]]
    if(length(x1[[i]]) != endpd | sum(is.na(x1[[i]])) > 0 | typeof(x1[[i]]) != "double" ) {print(paste("check draw",i))}
  }
  isaves = t(x3)

  to.read = file(paste(estpath,"hb/alldraws_c.dat",sep=""),"rt")
  x=readLines(to.read)
  close(to.read)

  x = x[1:length(x)%%2==0]
  x1 = strsplit(x," ")
  x3 = matrix(0,nrow=endpd,ncol=nend)
  for(i in 1:nend) {
    x1[[i]] = as.double(x1[[i]][x1[[i]] != ""])
    x3[,i] = x1[[i]]
    if(length(x1[[i]]) != endpd | sum(is.na(x1[[i]])) > 0 | typeof(x1[[i]]) != "double" ) {print(paste("check draw",i))}
  }
  csaves = t(x3)

  allid = unique(hhall4$hhid)

  to.read = file(paste(estpath,"hb/alldraws_u_types.dat",sep=""),"rt")
  x=readLines(to.read)
  close(to.read)

  x = x[1:length(x)%%2==0]
  x1 = strsplit(x," ")
  x3 = matrix(0,nrow=2*endpd,ncol=nend)
  for(i in 1:nend) {
    x1[[i]] = as.double(x1[[i]][x1[[i]] != ""])
    x3[,i] = x1[[i]]
    if(length(x1[[i]]) != 2*endpd | sum(is.na(x1[[i]])) > 0 | typeof(x1[[i]]) != "double" ) {print(paste("check draw",i))}
  }
  usaves.types = t(x3)

  to.read = file(paste(estpath,"hb/alldraws_types.dat",sep=""),"rt")
  x=readLines(to.read)
  close(to.read)

  x = x[1:length(x)%%2==0]
  x1 = strsplit(x," ")
  x3 = matrix(0,nrow=dim(hhweek)[3],ncol=nend)
  for(i in 1:nend) {
    x1[[i]] = as.double(x1[[i]][x1[[i]] != ""])
    x3[,i] = x1[[i]]
    if(length(x1[[i]]) != dim(hhweek)[3] | sum(is.na(x1[[i]])) > 0 | typeof(x1[[i]]) != "double" ) {print(paste("check draw",i))}
  }
  typesaves = t(x3)

  meantype = apply(typesaves[seq(nstart,nend,nskip),],2,mean)

  # identify stockpilers and non-stockpilers

  stockpiler = meantype > 0.5

  # load in the individual-specific average draws

  hbdraws = read.table(paste(estpath,"hb/hbmeans.dat",sep=""))

  drawmeans = vector("list",length=2)

  drawmeans[[1]] = apply(hbdraws[!stockpiler,],2,mean)
  drawmeans[[2]] = apply(hbdraws[stockpiler,],2,mean)

  # load in consumption and inventory by type

  to.read = file(paste(estpath,"hb/alldraws_i_types.dat",sep=""),"rt")
  x=readLines(to.read)
  close(to.read)

  x = x[1:length(x)%%2==0]
  x1 = strsplit(x," ")
  x3 = matrix(0,nrow=2*endpd,ncol=nend)
  for(i in 1:nend) {
    x1[[i]] = as.double(x1[[i]][x1[[i]] != ""])
    x3[,i] = x1[[i]]
    if(length(x1[[i]]) != 2*endpd | sum(is.na(x1[[i]])) > 0 | typeof(x1[[i]]) != "double" ) {print(paste("check draw",i))}
  }
  isaves.types = t(x3)

  to.read = file(paste(estpath,"hb/alldraws_c_types.dat",sep=""),"rt")
  x=readLines(to.read)
  close(to.read)

  x = x[1:length(x)%%2==0]
  x1 = strsplit(x," ")
  x3 = matrix(0,nrow=2*endpd,ncol=nend)
  for(i in 1:nend) {
    x1[[i]] = as.double(x1[[i]][x1[[i]] != ""])
    x3[,i] = x1[[i]]
    if(length(x1[[i]]) != 2*endpd | sum(is.na(x1[[i]])) > 0 | typeof(x1[[i]]) != "double" ) {print(paste("check draw",i))}
  }
  csaves.types = t(x3)

  hhidsubseta = vector("list",length=2)
  hhidsubsetb = vector("list",length=2)

  for(k in 1:2) {
    if(k == 1) {
      hhidsubseta[[1]] = hhall4$hhid %in% allid[!stockpiler]
      hhidsubsetb[[1]] = hhpurch$hhid %in% allid[!stockpiler]
    } else {
      hhidsubseta[[2]] = hhall4$hhid %in% allid[stockpiler]
      hhidsubsetb[[2]] = hhpurch$hhid %in% allid[stockpiler]
    }
  }

  pcoeff = exp(asaves[,nupc+4] + 0.5*dsaves[,nupc+4])

  quants = array(0,c(nweek,length(storeids),nupc))
  prices = array(0,c(nweek,length(storeids),nupc))
  rprices = array(0,c(nweek,length(storeids),nupc))
  qbytype = array(0,c(nweek,length(storeids),nupc,2))

  for(st in storeids) {
    for(i in minweek:maxweek) {

      for(j in 1:nupc) {
        x = hhall4$week == allweek[i] & hhall4$storeid == st & hhall4$upc == upckeep[j]
        quants[i-minweek+1,which(storeids==st),j] = sum(hhall4$unitswk[x])
        prices[i-minweek+1,which(storeids==st),j] = round(sasprices[st,i,j],0)
        rprices[i-minweek+1,which(storeids==st),j] = round(regprices[st,i,j],0)
        for(k in 1:2) {
          qbytype[i-minweek+1,which(storeids==st),j,k] = sum(hhall4$unitswk[x & hhidsubseta[[k]]])
        }
      }

    }

  }

  stshares = matrix(0,nrow=endpd,ncol=length(storeids))
  stshbytype = array(0,c(endpd,length(storeids),2))

  for(st in 1:length(storeids)) {
    for(i in 1:endpd) {
      stshares[i,st] = sum(hhpurch$week == allweek[i] & hhpurch$storeid == storeids[st])
      for(k in 1:2) {
        stshbytype[i,st,k] = sum(hhpurch$week == allweek[i] & hhpurch$storeid == storeids[st] & hhidsubsetb[[k]])
      }
    }
  }

  # create inclusive values
  coefd = dim(asaves)[2]
  nhhs = dim(hhweek)[3]
  hhcoefs = array(0,c(coefd,nhhs,nend-nstart+1))
  for(i in 1:nhhs) {
    hhcoefs[,i,] = t(asaves[nstart:nend,])
  }
  numprods = 6
  inputs = list(nhhs = as.integer(nhhs),nparam = as.integer(coefd),
                nproduct = as.integer(numprods),
                nwparam = as.integer(dim(hhweek)[1]),
                nweek = as.integer(dim(hhweek)[2]),
                ndraws = as.integer(nend-nstart+1),
                nskip = as.integer(10),
                bigj = as.integer(10))

  npbig = numprods+7
  # variable transformations that follow the fortran code
  inputs$coeffull = rep(0,npbig)
  inputs$coeffull[numprods+2] = log(1e-10)
  inputs$notest = rep(FALSE,npbig)
  inputs$notest[c(1,numprods+2)] = TRUE
  inputs$negcoefs = rep(1,npbig)
  inputs$poscoefs = rep(0,npbig)
  inputs$expcoefs = rep(TRUE,npbig)
  inputs$expcoefs[1:numprods] = FALSE
  inputs$expcoefs[numprods+c(5,6,7)] = FALSE

  sourceCpp("index_code.cpp")

  ivout = computeivcpptuna(hhcoefs,inputs,as.vector(hhweek))

  save(asaves,dsaves,usaves,isaves,csaves,allid,usaves.types,csaves.types,isaves.types,typesaves,meantype,hhidsubseta,hhidsubsetb,quants,prices,
       rprices,qbytype,stshares,stshbytype,ivout,file=paste(estpath,"tunaindexdata.RData",sep=""))

}

do.ind = c(1,2,3,4)

for(ind.i in do.ind) {

  load(paste(estpath,"tunaindexdata.RData",sep=""))
  save(allid,file=paste(estpath,"tuna_hhids.RData",sep=""))

  # create simple indexes

  modalprices = FALSE      # use modal prices in 1 month base index (only for standard indexes)
  rebase = FALSE           # TRUE: rebase each index so they start at 1 in each period (or avg to 1 in init month case)

  fsmodeshare = TRUE      # TRUE: use modal prices in FS base share, otherwise follow CCD

  if(ind.i == 1) {

    pd1flag = TRUE        #TRUE: use initial period from data, otherwise follow feenstra & shapiro
    basepd = 22
    initmonth = FALSE     #FALSE: when using initial period from data, do 1st week; o/w use initmd weeks
    initmd = 3            #number of weeks to include in initial period (if initmonth = TRUE)

  } else if (ind.i == 2) {

    pd1flag = TRUE        #TRUE: use initial period from data, otherwise follow feenstra & shapiro
    basepd = 22
    initmonth = TRUE      #FALSE: when using initial period from data, do 1st week; o/w use initmd weeks
    initmd = 3            #number of weeks to include in initial period (if initmonth = TRUE)

  } else if (ind.i == 3) {

    pd1flag = TRUE       #TRUE: use initial period from data, otherwise follow feenstra & shapiro
    basepd = 27
    initmonth = TRUE     #FALSE: when using initial period from data, do 1st week; o/w use initmd weeks
    initmd = 16            #number of weeks to include in initial period (if initmonth = TRUE)

  } else if (ind.i == 4) {

    pd1flag = TRUE        #TRUE: use initial period from data, otherwise follow feenstra & shapiro
    basepd = 22 #52
    initmonth = TRUE      #FALSE: when using initial period from data, do 1st week; o/w use initmd weeks
    initmd = 7            #number of weeks to include in initial period (if initmonth = TRUE)

  }

  startpd = basepd

  # create weights for laspeyres and chained indexes

  # impute missing prices

  zerop = apply(prices[startpd:endpd,,]==0,c(2,3),sum)

  # do imputations when some prices are missing. There are also cases where
  # almost all prices are missing for a particular store - zero these out
  for(st in 1:length(storeids)) {
    for(i in 1:length(upckeep)) {
      if(zerop[st,i] > 0 & zerop[st,i] < 0.75*(endpd-startpd+1)) {
        indx = min(which(prices[startpd:endpd,st,i] == 0))
        if(indx > 1) {
          prices[startpd:endpd,st,i][prices[startpd:endpd,st,i] == 0] = prices[startpd:endpd,st,i][indx-1]
          rprices[startpd:endpd,st,i][prices[startpd:endpd,st,i] == 0] = prices[startpd:endpd,st,i][indx-1]
        } else {
          indx = max(which(prices[startpd:endpd,st,i] == 0))
          prices[startpd:endpd,st,i][prices[startpd:endpd,st,i] == 0] = prices[startpd:endpd,st,i][indx+1]
          rprices[startpd:endpd,st,i][prices[startpd:endpd,st,i] == 0] = prices[startpd:endpd,st,i][indx+1]
        }
      } else if (zerop[st,i] >= 0.75*(endpd-startpd+1)) {
        prices[,st,i] = 0
        rprices[,st,i] = 0
        quants[,st,i] = 0
        qbytype[,st,i,] = 0
      }
    }
  }

  # remove stores where nobody shops after a certain period of time

  # store 2 drops out, and store 43 pops in later (at period 56-57)
  # these stores are in the same chain
  # their prices are the same for all but 1 upc, so a reasonable
  # imputation here is to assume prices are the same where they aren't
  # observed.

  prices[57:endpd,1,] = prices[57:endpd,18,]
  prices[1:56,18,] = prices[1:56,1,]

  rprices[57:endpd,1,] = rprices[57:endpd,18,]
  rprices[1:56,18,] = rprices[1:56,1,]

  # compute time series stats on prices

  price2 = prices
  price2[price2==0] = NA
  sdprice = apply(price2[startpd:endpd,,],1,sd,na.rm=TRUE)
  meanprice = apply(price2[startpd:endpd,,],1,mean,na.rm=TRUE)
  minprice = apply(price2[startpd:endpd,,],1,min,na.rm=TRUE)
  minpriceall = apply(price2,1,min,na.rm=TRUE)
  minpricestore = apply(price2[,,],c(1,2),min,na.rm=TRUE)
  maxpricestore = apply(price2[,,],c(1,2),max,na.rm=TRUE)

  # compute these stats on a product-by product basis

  sdprice.bybrand = apply(price2[startpd:endpd,,],c(1,3),sd,na.rm=TRUE)
  meanprice.bybrand = apply(price2[startpd:endpd,,],c(1,3),mean,na.rm=TRUE)
  minprice.bybrand = apply(price2[startpd:endpd,,],c(1,3),min,na.rm=TRUE)
  minprice.2brand = apply(price2[startpd:endpd,,1:4],1,min,na.rm=TRUE)

  dropstore = c(12,13,14,15,17,19)

  quants = quants[,-dropstore,]
  prices = prices[,-dropstore,]
  rprices = rprices[,-dropstore,]
  qbytype = qbytype[,-dropstore,,]

  # compute store level quantity shares

  stweights = apply(stshares,2,sum)
  stweights = stweights/sum(stweights)
  stweights = stweights[-dropstore]
  minpricestore = minpricestore[,-dropstore]
  maxpricestore = maxpricestore[,-dropstore]

  stweightbytype = apply(stshbytype,c(2,3),sum)
  stweightbytype = t(t(stweightbytype)/apply(stweightbytype,2,sum))
  stweightbytype = stweightbytype[-dropstore,]

  bsharebytype = apply(qbytype,c(3,4),sum)
  bsharebytype = t(t(bsharebytype)/apply(bsharebytype,2,sum))

  # compute average prices and total quantities

  qm = apply(quants,1,sum)
  pm = apply(quants*prices,1,sum)/qm

  tt = startpd:endpd
  res <- lm(log(pm[startpd:endpd])~tt)

  fit <- exp(res$fitted.values)

  # compute price indexes from Feenstra and Shapiro

  wt0 = matrix(0,nrow=length(prices[1,,1]),ncol=length(upckeep))
  p0 = matrix(0,nrow=length(prices[1,,1]),ncol=length(upckeep))
  q0 = matrix(0,nrow=length(prices[1,,1]),ncol=length(upckeep))
  q0bytype = array(0,c(length(prices[1,,1]),length(upckeep),2))
  denom = sum(quants[(startpd):(startpd+initmd),,]*prices[(startpd):(startpd+initmd),,])

  for(j in 1:length(upckeep)) {
    for(i in 1:length(prices[1,,j])) {
      if(pd1flag & initmonth) {
        if(!modalprices) {
          q0[i,j] = sum(quants[(startpd):(startpd+initmd),i,j])
          p0[i,j] = mean(prices[(startpd):(startpd+initmd),i,j])
          for(k in 1:2) {
            q0bytype[i,j,k] = sum(qbytype[(startpd):(startpd+initmd),i,j,k])
          }
        } else {
          ptab = table(prices[(startpd):(startpd+initmd),i,j])
          pnames = as.integer(names(ptab))
          if(pnames[1] == 0 & length(ptab) > 1) {
            ptab = ptab[2:length(ptab)]
            pnames = pnames[2:length(pnames)]
          }
          modeprice = min(pnames[ptab==max(ptab)])
          p0[i,j] = modeprice
          qsmall = quants[(startpd):(startpd+initmd),i,j]
          q0[i,j] = mean(qsmall[prices[(startpd):(startpd+initmd),i,j]==p0[i,j]] )
          for(k in 1:2) {
            qq = qbytype[(startpd):(startpd+initmd),i,j,k]
            q0bytype[i,j,k] = mean(qq[prices[(startpd):(startpd+initmd),i,j]==p0[i,j]] )
          }
        }
      } else if (pd1flag & !initmonth) {
        p0 = prices[basepd,,]
        q0 = quants[basepd,,]
        q0bytype = qbytype[basepd,,,]
      } else {
        ptab = table(prices[(startpd-initmd-1):(startpd-1),i,j])
        pnames = as.integer(names(ptab))
        if(pnames[1] == 0 & length(ptab) > 1) {
          ptab = ptab[2:length(ptab)]
          pnames = pnames[2:length(pnames)]
        }
        modeprice = min(pnames[ptab==max(ptab)])
        p0[i,j] = modeprice
        qsmall = quants[(startpd-initmd-1):(startpd-1),i,j]
        q0[i,j] = mean(qsmall[prices[(startpd-initmd-1):(startpd-1),i,j]==p0[i,j]] )
        for(k in 1:2) {
          qq = qbytype[(startpd-initmd-1):(startpd-1),i,j,k]
          q0bytype[i,j,k] = mean(qq[prices[(startpd-initmd-1):(startpd-1),i,j]==p0[i,j]] )
        }
      }
    }
  }
  wt0 = p0*q0/sum(p0*q0)
  wt0bytype = q0bytype
  for(k in 1:2) {
    wt0bytype[,,k] = p0*q0bytype[,,k]/sum(p0*q0bytype[,,k])
  }

  wt=array(0,c(endpd,length(prices[1,,1]),length(upckeep)))
  wtt0=array(0,c(endpd,length(prices[1,,1]),length(upckeep)))  #for the Paasche index

  for(i in startpd:endpd) {
    wt[i,,] = prices[i,,]*quants[i,,]/sum(prices[i,,]*quants[i,,])
    wtt0[i,,] = p0*quants[i,,]/sum(p0*quants[i,,])
  }

  st = array(0,dim(quants))
  iiv = c(rep(-1,startpd-1),as.integer((startpd:endpd-startpd)/(initmd+1))+1)
  for(i in startpd:endpd) {
    ii = as.integer((i-startpd)/(initmd+1))+1
    if(ii > 0) {
      ydenom = sum(quants[iiv==ii,,]*prices[iiv==ii,,])
      st[i,,] = quants[i,,]*prices[i,,]/ydenom
    }
  }

  if(!fsmodeshare) {
    s0 = st[iiv==1,,]
    p00 = prices[iiv==1,,]
    s0bytype = q0bytype
    for(k in 1:2) {
      s0bytype[,,k] = p0*q0bytype[,,k]/sum(prices[startpd:(startpd+initmd),,]*qbytype[startpd:(startpd+initmd),,,k])
    }
  } else {
    if(pd1flag) {
      # replicate feenstra and shapiro
      p00 = matrix(0,nrow=length(prices[1,,1]),ncol=length(upckeep))
      q00 = matrix(0,nrow=length(prices[1,,1]),ncol=length(upckeep))
      for(j in 1:length(upckeep)) {
        for(i in 1:length(prices[1,,j])) {
          ptab = table(prices[(startpd):(startpd+initmd),i,j])
          pnames = as.integer(names(ptab))
          if(pnames[1] == 0 & length(ptab) > 1) {
            ptab = ptab[2:length(ptab)]
            pnames = pnames[2:length(pnames)]
          }
          modeprice = min(pnames[ptab==max(ptab)])
          p00[i,j] = modeprice
          qsmall = quants[(startpd):(startpd+initmd),i,j]
          q00[i,j] = mean(qsmall[prices[(startpd):(startpd+initmd),i,j]==p00[i,j]] )
        }
      }
      s0 = p00*q00/sum(prices[startpd:(startpd+initmd),,]*quants[startpd:(startpd+initmd),,])
      s0bytype = q0bytype
      for(k in 1:2) {
        s0bytype[,,k] = p0*q0bytype[,,k]/sum(prices[startpd:(startpd+initmd),,]*qbytype[startpd:(startpd+initmd),,,k])
      }
    } else {
      s0 = p0*q0/sum(prices[(startpd-initmd-1):(startpd-1),,]*quants[(startpd-initmd-1):(startpd-1),,])
      s0bytype = q0bytype
      for(k in 1:2) {
        s0bytype[,,k] = p0*q0bytype[,,k]/sum(prices[(startpd-initmd-1):(startpd-1),,]*qbytype[(startpd-initmd-1):(startpd-1),,,k])
      }
    }
  }

  laspeyres = rep(0,nweek)
  unitvalue = rep(0,nweek)
  paasche = rep(0,nweek)
  fisher = rep(0,nweek)
  laspeyres.c = rep(0,nweek)
  fbgeo = rep(0,nweek)
  fbgeo.bls = rep(0,nweek)
  tornqvist = rep(0,nweek)
  tornqvist.c = rep(0,nweek)
  bestprice = vector("list",length=4)
  for(i in 1:4) {
    bestprice[[i]] = rep(0,nweek)
  }
  if(pd1flag) {
    coli.months = seq(startpd,endpd,initmd+1)
    coli.fs = rep(0,length(coli.months))
  } else {
    coli.fs = 0
  }
  laspbytype = list(rep(0,nweek),rep(0,nweek))
  bpbytype = vector("list",length=8)
  bpbytype.coli = vector("list",length=8)
  for(i in 1:8) {
    bpbytype[[i]] = rep(0,nweek)
    bpbytype.coli[[i]] = rep(0,nweek)
  }
  coli.fs.bytype = list(coli.fs,coli.fs)

  tq.wtmeans = c(0,0)
  fs.wtmeans = c(0,0)

  tq.save = array(0,c(endpd,length(prices[1,,1]),length(upckeep)))

  laspeyres.big[[ind.i]] = rep(0,endpd)
  regprice.big[[ind.i]] = rep(0,endpd)
  dealprice.big[[ind.i]] = rep(0,endpd)
  dealfreq.big[[ind.i]] = rep(0,endpd)
  dealspread.big[[ind.i]] = rep(0,endpd)
  bestprice.big[[ind.i]] = vector("list",length=4)
  worstprice.big[[ind.i]] = vector("list",length=4)
  modeprice.big[[ind.i]] = vector("list",length=4)
  modeminspread.big[[ind.i]] = vector("list",length=4)
  maxminspread.big[[ind.i]] = vector("list",length=4)
  meanminspread.big[[ind.i]] = vector("list",length=4)
  for(i in 1:4) {
    bestprice.big[[ind.i]][[i]] = rep(0,endpd)
    worstprice.big[[ind.i]][[i]] = rep(0,endpd)
    modeprice.big[[ind.i]][[i]] = rep(0,endpd)
    modeminspread.big[[ind.i]][[i]] = rep(0,endpd)
    meanminspread.big[[ind.i]][[i]] = rep(0,endpd)
    maxminspread.big[[ind.i]][[i]] = rep(0,endpd)
  }

  for(i in 1:(startpd-1)) {
    laspeyres.big[[ind.i]][i] = sum( wt0*prices[i,,]/pmax(p0,1) )
    regprice.big[[ind.i]][i] = sum( wt0*rprices[i,,] )
    dealfreq.big[[ind.i]][i] = sum((prices[i,,] < (1-dealpct)*pmax(rprices[i,,],prices[i,,])))/sum(wt0>0)
    temp.sp = prices[i,,] < (1-dealpct)*pmax(rprices[i,,],prices[i,,])
    temp.sp[!temp.sp] = NA
    wt0.sp = wt0
    wt0.sp[is.na(temp.sp)] = 0
    wt0.sp = wt0.sp/sum(wt0.sp)
    dealspread.big[[ind.i]][i] = sum(wt0.sp*(pmax(rprices[i,,],prices[i,,]) - prices[i,,])*temp.sp,na.rm=TRUE)
    dealprice.big[[ind.i]][i] = sum(wt0.sp*prices[i,,]*temp.sp,na.rm=TRUE)
    for(j in 1:4) {
      if(initmonth) {
        ii = i-startpd+1
        if(j <= 2) {
          il = initmd+1
        } else {
          il = 2*(initmd+1)
        }
        offset = -((ii-1)%%il)
        maxindx = min(endpd,il + startpd-1+ii+offset-1)-(startpd-1+ii+offset)+1
      } else {
        ii = i-startpd+1
        offset = 0
        maxindx = 1
      }
      if(maxindx<=0) {
        stop("maxindxbug")
      }
      if(maxindx==1) {
        if(j%%2 == 1) {
          bpwt = stweights
        } else {
          bpwt = stshares[startpd-1+ii+offset,-dropstore]
          bpwt = bpwt/sum(bpwt)
        }
        bestprice.big[[ind.i]][[j]][i] = sum(minpricestore[startpd-1+ii+offset,]*bpwt)
        worstprice.big[[ind.i]][[j]][i] = sum(maxpricestore[startpd-1+ii+offset,]*bpwt)
        modeprice.big[[ind.i]][[j]][i] = sum(prices[startpd-1+ii+offset,,]*wt[startpd-1+ii+offset,,])
        modeminspread.big[[ind.i]][[j]][i] = 0
        maxminspread.big[[ind.i]][[j]][i] = 0
        meanminspread.big[[ind.i]][[j]][i] = 0
      } else {
        offset = -((ii-1)%%il)-1
        iii = 1:maxindx + startpd-1+ii+offset
        iii = iii[iii>0]
        if(j%%2 == 1) {
          bpwt = stweights
        } else if (k%%4 == 2) {
          if(length(iii) == 1) {
            bpwt = stshares[iii,-dropstore]
          } else {
            bpwt = apply(stshares[iii,-dropstore],2,sum)
          }
          bpwt = bpwt/sum(bpwt)
        }
        if(length(iii) == 1) {
          bestprice.big[[ind.i]][[j]][i] = sum(minpricestore[iii,]*bpwt)
          worstprice.big[[ind.i]][[j]][i] = sum(maxpricestore[iii,]*bpwt)
          modeprice.big[[ind.i]][[j]][i] = sum(prices[iii,,]*wt[iii,,])
          modeminspread.big[[ind.i]][[j]][i] = 0
          maxminspread.big[[ind.i]][[j]][i] = 0
          meanminspread.big[[ind.i]][[j]][i] = 0
        } else {
          bestprice.big[[ind.i]][[j]][i] = sum(apply(minpricestore[iii,],2,min)*bpwt)
          worstprice.big[[ind.i]][[j]][i] = sum(apply(maxpricestore[iii,],2,max)*bpwt)
          dd = attr(prices,"dim")[2:3]
          modepsmall = array(0,dd)
          meanpsmall = array(0,dd)
          minpsmall = array(0,dd)
          maxpsmall = array(0,dd)
          for(sti in 1:dd[1]) {
            for(jj in 1:dd[2]) {
              ptab = table(prices[iii,sti,jj])
              pnames = as.integer(names(ptab))
              if(pnames[1] == 0 & length(ptab) > 1) {
                ptab = ptab[2:length(ptab)]
                pnames = pnames[2:length(pnames)]
              }
              modepsmall[sti,jj] = min(pnames[ptab==max(ptab)])

              minpsmall[sti,jj] = min(price2[iii,sti,jj],na.rm=TRUE)
              if(!is.finite(minpsmall[sti,jj])) {
                minpsmall[sti,jj] = 0
              }
              maxpsmall[sti,jj] = max(price2[iii,sti,jj],na.rm=TRUE)
              if(!is.finite(maxpsmall[sti,jj])) {
                maxpsmall[sti,jj] = 0
              }
              meanpsmall[sti,jj] = mean(price2[iii,sti,jj],na.rm=TRUE)
              if(!is.finite(meanpsmall[sti,jj])) {
                meanpsmall[sti,jj] = 0
              }
            }
          }
          modeprice.big[[ind.i]][[j]][i] = sum(modepsmall*wt0)
          modeminspread.big[[ind.i]][[j]][i] = sum((modepsmall-minpsmall)*wt0)
          maxminspread.big[[ind.i]][[j]][i] = sum((maxpsmall-minpsmall)*wt0)
          meanminspread.big[[ind.i]][[j]][i] = sum((meanpsmall-minpsmall)*wt0)
        }
      }
    }

  }

  for(i in startpd:endpd) {

    salepd = prices[i,,] < 59
    wt1 = wt[i,,]
    st1 = st[i,,]

    tq.wtmeans[1] = tq.wtmeans[1] + mean(wt0[salepd] + wt1[salepd])
    tq.wtmeans[2] = tq.wtmeans[2] + mean(wt0[!salepd] + wt1[!salepd])

    fs.wtmeans[1] = fs.wtmeans[1] + mean(s0[salepd] + st1[salepd])
    fs.wtmeans[2] = fs.wtmeans[2] + mean(s0[!salepd] + st1[!salepd])

    laspeyres[i] = sum( wt0*prices[i,,]/pmax(p0,1) )
    laspeyres.big[[ind.i]][i] = laspeyres[i]
    regprice.big[[ind.i]][i] = sum( wt0*rprices[i,,] )
    dealfreq.big[[ind.i]][i] = sum((prices[i,,] < (1-dealpct)*pmax(rprices[i,,],prices[i,,])))/sum(wt0>0)
    temp.sp = prices[i,,] < (1-dealpct)*pmax(rprices[i,,],prices[i,,])
    temp.sp[!temp.sp] = NA
    wt0.sp = wt0
    wt0.sp[is.na(temp.sp)] = 0
    wt0.sp = wt0.sp/sum(wt0.sp)
    dealspread.big[[ind.i]][i] = sum(wt0.sp*(pmax(rprices[i,,],prices[i,,]) - prices[i,,])*temp.sp,na.rm=TRUE)
    dealprice.big[[ind.i]][i] = sum(wt0.sp*prices[i,,]*temp.sp,na.rm=TRUE)
    for(k in 1:2) {
      laspbytype[[k]][i] = sum( wt0bytype[,,k]*prices[i,,]/pmax(p0,1) )
    }
    paasche[i] = sum( wtt0[i,,]*prices[i,,]/pmax(p0,1) )
    if(!initmonth) {
      unitvalue[i] = sum( wtt0[i,,]*prices[i,,] )
    }
    fisher[i] = sqrt(laspeyres[i]*paasche[i])
    fbgeo[i] = exp(sum( wt0*log(pmax(prices[i,,],1)/pmax(p0,1)) ))
    tornqvist[i] = exp( sum( 0.5*(wt0+wt[i,,])*log(pmax(prices[i,,],1)/pmax(p0,1)) ) )
    tq.save[i,,] = 0.5*(wt0+wt[i,,])
    if(pd1flag) {
      ii = as.integer((i-startpd)/(initmd+1))+1
      if(ii > 0) {
        if(fsmodeshare) {
          coli.fs[ii] = coli.fs[ii] + sum( 0.5*(s0+st[i,,])*log(pmax(prices[i,,],1)/pmax(p00,1)) )
          for(k in 1:2) {
            coli.fs.bytype[[k]][ii] = coli.fs.bytype[[k]][ii] + sum( 0.5*(s0bytype[,,k]+st[i,,])*log(pmax(prices[i,,],1)/pmax(p00,1)) )
          }
        } else {
          ind = i-startpd-(initmd+1)*(ii-1)+1
          coli.fs[ii] = coli.fs[ii] + sum( 0.5*(s0[ind,,]+st[i,,])*log(pmax(prices[i,,],1)/pmax(p00[ind,,],1)) )
          for(k in 1:2) {
            coli.fs.bytype[[k]][ii] = coli.fs.bytype[[k]][ii] + sum( 0.5*(s0bytype[,,k]+st[i,,])*log(pmax(prices[i,,],1)/pmax(p0,1)) )
          }
        }
      }
    } else {
      coli.fs = coli.fs + sum( 0.5*(s0+st[i,,])*log(pmax(prices[i,,],1)/pmax(p0,1)) )
      for(k in 1:2) {
        coli.fs.bytype[[k]] = coli.fs.bytype[[k]] + sum( 0.5*(s0bytype[,,k]+st[i,,])*log(pmax(prices[i,,],1)/pmax(p0,1)) )
      }
    }
    if(i > 1) {
      laspeyres.c[i] = sum( wt[i-1,,]*(prices[i,,]/pmax(prices[i-1,,],1)) )
      tornqvist.c[i] = exp( sum( 0.5*(wt[i,,]+wt[i-1,,])*log(pmax(prices[i,,],1)/pmax(prices[i-1,,],1)) ) )
    }

    for(j in 1:4) {
      if(initmonth) {
        ii = i-startpd+1
        if(j <= 2) {
          il = initmd+1
        } else {
          il = 2*(initmd+1)
        }
        offset = -((ii-1)%%il)
        maxindx = min(endpd,il + startpd-1+ii+offset-1)-(startpd-1+ii+offset)+1
      } else {
        ii = i-startpd+1
        offset = 0
        maxindx = 1
      }
      if(maxindx<=0) {
        stop("maxindxbug")
      }
      if(maxindx==1) {
        if(j%%2 == 1) {
          bpwt = stweights
        } else {
          bpwt = stshares[startpd-1+ii+offset,-dropstore]
          bpwt = bpwt/sum(bpwt)
        }
        if(j==1 & initmonth) {
          unitvalue[i] = sum( wtt0[startpd-1+ii+offset,,]*prices[startpd-1+ii+offset,,] )
        }
        bestprice[[j]][i] = sum(minpricestore[startpd-1+ii+offset,]*bpwt)
        worstprice.big[[ind.i]][[j]][i] = sum(maxpricestore[startpd-1+ii+offset,]*bpwt)
        modeprice.big[[ind.i]][[j]][i] = sum(prices[startpd-1+ii+offset,,]*wt[startpd-1+ii+offset,,])
        modeminspread.big[[ind.i]][[j]][i] = 0
        maxminspread.big[[ind.i]][[j]][i] = 0
        meanminspread.big[[ind.i]][[j]][i] = 0
        for(k in 1:2) {
          if(j%%2 == 1) {
            bpwt = stweightbytype[,k]
          } else {
            bpwt = stshbytype[startpd-1+ii+offset,-dropstore,k]
            bpwt = bpwt/sum(bpwt)
          }
          bpbytype[[j+4*(k-1)]][i] = sum(minpricestore[startpd-1+ii+offset,]*bpwt)
        }
      } else {
        offset = -((ii-1)%%il)-1
        if(j%%2 == 1) {
          bpwt = stweights
        } else if (k%%4 == 2) {
          bpwt = apply(stshares[1:maxindx + startpd-1+ii+offset,-dropstore],2,sum)
          bpwt = bpwt/sum(bpwt)
        }
        if(j==1 & initmonth) {
          unitvalue[i] = sum( wtt0[1:maxindx + startpd-1+ii+offset,,]*prices[1:maxindx + startpd-1+ii+offset,,] )
        }
        bestprice[[j]][i] = sum(apply(minpricestore[1:maxindx + startpd-1+ii+offset,],2,min)*bpwt)
        worstprice.big[[ind.i]][[j]][i] = sum(apply(maxpricestore[1:maxindx + startpd-1+ii+offset,],2,max)*bpwt)
        dd = attr(prices,"dim")[2:3]
        modepsmall = array(0,dd)
        meanpsmall = array(0,dd)
        minpsmall = array(0,dd)
        maxpsmall = array(0,dd)
        for(sti in 1:dd[1]) {
          for(jj in 1:dd[2]) {
            ptab = table(prices[1:maxindx + startpd-1+ii+offset,sti,jj])
            pnames = as.integer(names(ptab))
            if(pnames[1] == 0 & length(ptab) > 1) {
              ptab = ptab[2:length(ptab)]
              pnames = pnames[2:length(pnames)]
            }
            modepsmall[sti,jj] = min(pnames[ptab==max(ptab)])
            minpsmall[sti,jj] = min(price2[1:maxindx + startpd-1+ii+offset,sti,jj],na.rm=TRUE)
            if(!is.finite(minpsmall[sti,jj])) {
              minpsmall[sti,jj] = 0
            }
            maxpsmall[sti,jj] = max(price2[1:maxindx + startpd-1+ii+offset,sti,jj],na.rm=TRUE)
            if(!is.finite(maxpsmall[sti,jj])) {
              maxpsmall[sti,jj] = 0
            }
            meanpsmall[sti,jj] = mean(price2[1:maxindx + startpd-1+ii+offset,sti,jj],na.rm=TRUE)
            if(!is.finite(meanpsmall[sti,jj])) {
              meanpsmall[sti,jj] = 0
            }
          }
        }
        modeprice.big[[ind.i]][[j]][i] = sum(modepsmall*wt0)
        modeminspread.big[[ind.i]][[j]][i] = sum((modepsmall-minpsmall)*wt0)
        maxminspread.big[[ind.i]][[j]][i] = sum((maxpsmall-minpsmall)*wt0)
        meanminspread.big[[ind.i]][[j]][i] = sum((meanpsmall-minpsmall)*wt0)
        for(k in 1:2) {
          if(j%%2 == 1) {
            bpwt = stweightbytype[,k]
          } else {
            bpwt = apply(stshbytype[1:maxindx + startpd-1+ii+offset,-dropstore,k],2,sum)
            bpwt = bpwt/sum(bpwt)
          }
          bpbytype[[j+4*(k-1)]][i] = sum(apply(minpricestore[1:maxindx + startpd-1+ii+offset,],2,min)*bpwt)
        }
      }
      bestprice.big[[ind.i]][[j]][i] = bestprice[[j]][i]
    }

  }

  for(j in 1:4) {
    bestprice[[j]] = bestprice[[j]]/bestprice[[j]][startpd]
    for(k in 1:2) {
      bpbytype[[j+4*(k-1)]]=bpbytype[[j+4*(k-1)]]/bpbytype[[j+4*(k-1)]][startpd]
    }
  }

  laspeyres.c[startpd] = 1
  tornqvist.c[startpd] = 1
  unitvalue = unitvalue/unitvalue[startpd]

  for(i in (startpd+1):endpd) {
    laspeyres.c[i] = laspeyres.c[i-1]*laspeyres.c[i]
    tornqvist.c[i] = tornqvist.c[i-1]*tornqvist.c[i]
  }

  if(rebase & ind.i > 1) {
    if(ind.i == 2) {
      laspeyres = laspeyres[startpd:endpd]/mean(laspeyres[startpd-1 + 1:(initmd+1)])
      fbgeo = fbgeo[startpd:endpd]/mean(fbgeo[startpd-1 + 1:(initmd+1)])
      paasche = paasche[startpd:endpd]/mean(paasche[startpd-1 + 1:(initmd+1)])
      fisher = fisher[startpd:endpd]/mean(fisher[startpd-1 + 1:(initmd+1)])
      tornqvist=tornqvist[startpd:endpd]/mean(tornqvist[startpd-1 + 1:(initmd+1)])
      laspeyres.c=laspeyres.c[(startpd):endpd]/mean(laspeyres.c[startpd-1 + 1:(initmd+1)])
      tornqvist.c=tornqvist.c[(startpd):endpd]/mean(tornqvist.c[startpd-1 + 1:(initmd+1)])
    } else {
      laspeyres = laspeyres[startpd:endpd]/laspeyres[basepd]
      fbgeo = fbgeo[startpd:endpd]/fbgeo[basepd]
      paasche = passche[startpd:endpd]/paasche[basepd]
      fisher = fisher[startpd:endpd]/fisher[basepd]
      tornqvist=tornqvist[startpd:endpd]/tornqvist[basepd]
      laspeyres.c=laspeyres.c[(startpd):endpd]/laspeyres.c[basepd]
      tornqvist.c=tornqvist.c[(startpd):endpd]/tornqvist.c[basepd]
    }
  } else {
    laspeyres = laspeyres[startpd:endpd]
    unitvalue = unitvalue[startpd:endpd]
    paasche = paasche[startpd:endpd]
    fisher = fisher[startpd:endpd]
    fbgeo = fbgeo[startpd:endpd]
    tornqvist=tornqvist[startpd:endpd]
    laspeyres.c=laspeyres.c[(startpd):endpd]
    tornqvist.c=tornqvist.c[(startpd):endpd]
    for(k in 1:2) {
      laspbytype[[k]] = laspbytype[[k]][startpd:endpd]
    }
  }

  coli.fs = exp(coli.fs)
  for(k in 1:2) {
    coli.fs.bytype[[k]] = exp(coli.fs.bytype[[k]])
  }
  if(rebase & ind.i == 2) {coli.fs = coli.fs/coli.fs[1]}

  # compute ratio of expenditure weights

  ivout$ut[ivout$ut==0] = NA

  # compute dynamic cost of living index

  if(pd1flag & initmonth) {

    # compute base utilities using month 1

    avgu = rep(0,length(usaves[,startpd]))
    for(i in startpd:(startpd+initmd)) {
      avgu = avgu + (usaves[,i])/(initmd+1)
    }
    comp = (usaves - avgu)

    udiff = 1+(usaves - avgu)/avgu

    mean.util = apply(usaves[seq(nstart,nend,nskip),startpd:endpd],2,mean)

    mean.ivutil = apply(ivout$ut,2,mean,na.rm=TRUE)

    mean.iv = apply(ivout$iv,2,mean,na.rm=TRUE)

    mean.coli = apply(comp[seq(nstart,nend,nskip),startpd:endpd],2,mean)

    mutil.type = vector("list",length=2)
    mcoli.type = vector("list",length=2)
    for(n in 1:2) {
      avgu = rep(0,length(usaves[,startpd]))
      for(i in startpd:(startpd+initmd)) {
        avgu = avgu + (usaves.types[,i+(n-1)*endpd])/(initmd+1)
      }
      comp1 = (usaves.types[,1:endpd+(n-1)*endpd] - avgu)

      mutil.type[[n]] = apply(usaves.types[seq(nstart,nend,nskip),startpd:endpd+(n-1)*endpd],2,mean)

      mcoli.type[[n]] = apply(comp1[seq(nstart,nend,nskip),startpd:endpd],2,mean)
    }

  } else if (pd1flag & !initmonth) {

    # compute base utilities using week 1

    comp = (usaves - usaves[,basepd])

    udiff = 1+(usaves - usaves[,basepd])/usaves[,basepd]

    mean.util = apply(usaves[seq(nstart,nend,nskip),startpd:endpd],2,mean)

    mean.ivutil = apply(ivout$ut,2,mean,na.rm=TRUE)

    mean.iv = apply(ivout$iv,2,mean,na.rm=TRUE)

    mean.coli = apply(comp[seq(nstart,nend,nskip),startpd:endpd],2,mean)

    mutil.type = vector("list",length=2)
    mcoli.type = vector("list",length=2)
    for(n in 1:2) {

      comp1 = (usaves.types[,1:endpd+(n-1)*endpd] - usaves.types[,(n-1)*endpd+basepd])

      mutil.type[[n]] = apply(usaves.types[seq(nstart,nend,nskip),startpd:endpd+(n-1)*endpd],2,mean)

      mcoli.type[[n]] = apply(comp1[seq(nstart,nend,nskip),startpd:endpd],2,mean)
    }


  } else {

    # compute base utilities using prior year

    avgu = rep(0,length(usaves[,1]))
    for(i in (startpd-initmd-1):(startpd-1)) {
      avgu = avgu + (usaves[,i])/(initmd+1)
    }
    comp = (usaves - avgu)

    udiff = 1+(usaves - avgu)/avgu

    mean.util = apply(usaves[seq(nstart,nend,nskip),startpd:endpd],2,mean)

    mean.ivutil = apply(ivout$ut,2,mean,na.rm=TRUE)

    mean.iv = apply(ivout$iv,2,mean,na.rm=TRUE)

    mean.coli = apply(comp[seq(nstart,nend,nskip),startpd:endpd],2,mean)

    mutil.type = vector("list",length=2)
    mcoli.type = vector("list",length=2)
    for(n in 1:2) {
      avgu = rep(0,length(usaves[,startpd]))
      for(i in (startpd-initmd-1):(startpd-1)) {
        avgu = avgu + (usaves.types[,i+(n-1)*endpd])/(initmd+1)
      }
      comp1 = (usaves.types[,1:endpd+(n-1)*endpd] - avgu)

      mutil.type[[n]] = apply(usaves.types[seq(nstart,nend,nskip),startpd:endpd+(n-1)*endpd],2,mean)

      mcoli.type[[n]] = apply(comp1[seq(nstart,nend,nskip),startpd:endpd],2,mean)
    }

  }

  mean.util.types = apply(usaves.types[seq(nstart,nend,nskip),],2,mean)

  mean.inv = apply(isaves[seq(nstart,nend,nskip),],2,mean)
  mean.cons = apply(csaves[seq(nstart,nend,nskip),],2,mean)

  # chained version of index

  comp1 = apply(usaves,1,diff)
  comp1 = t(comp1)
  comp1 = cbind(rep(0,nrow(comp1)),comp1)
  mean.coli1 = apply(comp1[seq(nstart,nend,nskip),],2,mean)

  if(pd1flag & initmonth) {
    if(!modalprices) {
      ap1 = sum(quants[(startpd):(startpd+initmd),,]*prices[(startpd):(startpd+initmd),,])/sum(quants[(startpd):(startpd+initmd),,])/100
    } else {
      ap1 =  sum(q0*p0/sum(q0))/100
    }
  } else {
    ap1 = sum(q0*p0/sum(q0))/100
  }


  coli.index = (ap1-mean.coli)/ap1
  coli.index1 = (ap1-mean.coli1)/ap1
  sd.coli = apply((ap1-comp[seq(nstart,nend,nskip),startpd:endpd])/ap1,2,sd)
  av.coli = apply((ap1-comp[seq(nstart,nend,nskip),startpd:endpd])/ap1,1,mean)
  av.coli1 = apply((ap1-comp1[seq(nstart,nend,nskip),startpd:endpd])/ap1,1,mean)
  centiles.coli = apply((ap1-comp[seq(nstart,nend,nskip),startpd:endpd])/ap1,2,quantile,probs=c(0.025,0.975))
  centiles.coli1 = apply((ap1-comp1[seq(nstart,nend,nskip),startpd:endpd])/ap1,2,quantile,probs=c(0.025,0.975))

  compsave[[ind.i]] = (ap1-comp[seq(nstart,nend,nskip),startpd:endpd])/ap1
  compsave2[[ind.i]] = comp[seq(nstart,nend,nskip),startpd:endpd]

  coli.index.types = vector("list",length=2)
  for(n in 1:2) {
    coli.index.types[[n]] = (ap1-mcoli.type[[n]])/ap1
  }

  l.coli = ap1-laspeyres*ap1
  lc.coli = ap1-laspeyres.c*ap1
  fisher.coli = ap1-fisher*ap1
  unitvalue.coli = ap1-unitvalue*ap1
  bestprice.coli = vector("list",length=4)
  for(j in 1:4) {
    bestprice.coli[[j]] = ap1-bestprice[[j]]*ap1
    for(k in 1:2) {
      bpbytype.coli[[j+4*(k-1)]]=ap1-bpbytype[[j+4*(k-1)]]*ap1
    }
  }
  fbgeo.coli = ap1-fbgeo*ap1
  t.coli = ap1-tornqvist*ap1
  tc.coli = ap1-tornqvist.c*ap1
  fs.coli = ap1-coli.fs*ap1

  # expand FS coli to monthly level
  if(pd1flag) {
    coli.fs1 = kronecker(coli.fs,rep(1,initmd+1))
    coli.fs1.bytype = list(kronecker(coli.fs.bytype[[1]],rep(1,initmd+1)),kronecker(coli.fs.bytype[[2]],rep(1,initmd+1)))
  } else {
    coli.fs1 = rep(coli.fs,endpd-startpd-3)
    coli.fs1.bytype = c(rep(coli.fs.bytype[[1]],endpd-startpd-3),rep(coli.fs.bytype[[1]],endpd-startpd-3))
  }

  fs1.coli = ap1-coli.fs1*ap1

  # Chevalier and Kashyap weighted average
  ckindex = vector("list",length=4)
  avgckfs = vector("list",length=4)
  ck.coli = vector("list",length=4)
  avg.coli = vector("list",length=4)

  for(j in 1:4) {
    ckindex[[j]] = (2/3)*laspeyres + (1/3)*bestprice[[j]][startpd:endpd]
    avgckfs[[j]] = 0.5*ckindex[[j]] + 0.5*coli.fs1[1:(endpd-startpd+1)]
    ck.coli[[j]] = ap1-ckindex[[j]]*ap1
    avg.coli[[j]] = ap1-avgckfs[[j]]*ap1
  }


  # create monthly version of dynamic index
  monthdelta = 3
  month.id = kronecker(1:as.integer((endpd-startpd+1)/(monthdelta+1)),rep(1,monthdelta+1))
  month.id = month.id[1:(endpd-startpd+1-(monthdelta+1))]

  coli.agg = aggregate(coli.index[(monthdelta+2):(endpd-startpd+1)],by=list(month.id),mean)
  coli.agg.m = kronecker(coli.agg$x,rep(1,monthdelta+1))
  coli.agg.m = coli.agg.m[1:(endpd-startpd+1-(monthdelta+1))]

  tq.agg = aggregate(tornqvist[(monthdelta+2):(endpd-startpd+1)],by=list(month.id),mean)
  tq.agg.m = kronecker(tq.agg$x,rep(1,monthdelta+1))
  tq.agg.m = tq.agg.m[1:(endpd-startpd+1-(monthdelta+1))]

  tt1 = 1:(endpd-startpd+1)

  res <- lm(log(coli.index)~tt1)
  coli.trend <- exp(res$fitted.values)

  coli.sd1 = centiles.coli[1,]
  coli.sd2 = centiles.coli[2,]

  index.list[[ind.i]]$laspeyres = laspeyres
  index.list[[ind.i]]$unitvalue = unitvalue
  index.list[[ind.i]]$paasche = paasche
  index.list[[ind.i]]$fisher = fisher
  index.list[[ind.i]]$tornqvist = tornqvist
  index.list[[ind.i]]$fbgeo = fbgeo
  index.list[[ind.i]]$laspeyres.c = laspeyres.c
  index.list[[ind.i]]$tornqvist.c = tornqvist.c
  index.list[[ind.i]]$coli.agg.m = coli.agg.m
  index.list[[ind.i]]$tq.agg.m = tq.agg.m
  index.list[[ind.i]]$coli.index = coli.index
  index.list[[ind.i]]$coli.fs1 = coli.fs1
  index.list[[ind.i]]$coli.sd1 = coli.sd1
  index.list[[ind.i]]$coli.sd2 = coli.sd2
  index.list[[ind.i]]$av.coli = av.coli
  index.list[[ind.i]]$bestprice = vector("list",length=4)

  index.list[[ind.i]]$l.coli = l.coli
  index.list[[ind.i]]$fisher.coli = fisher.coli
  index.list[[ind.i]]$unitvalue.coli = unitvalue.coli
  index.list[[ind.i]]$bestprice.coli = bestprice.coli
  index.list[[ind.i]]$t.coli = t.coli
  index.list[[ind.i]]$fs1.coli = fs1.coli
  index.list[[ind.i]]$mean.coli = mean.coli
  index.list[[ind.i]]$mcoli.type = mcoli.type
  index.list[[ind.i]]$bpbytype.coli = bpbytype.coli
  index.list[[ind.i]]$ck.coli = ck.coli
  index.list[[ind.i]]$avg.coli = avg.coli

  for(j in 1:4) {
    index.list[[ind.i]]$bestprice[[j]] = bestprice[[j]][startpd:endpd]
    index.list[[ind.i]]$bestprice.coli[[j]] = bestprice.coli[[j]][startpd:endpd]
  }

  if(ind.i == 2) {
    index.list[[ind.i]]$coli.fs = coli.fs
    index.list[[ind.i]]$laspeyres.monthly = aggregate(laspeyres[(initmd+2):(endpd-startpd+1)],by=list(month.id),mean)$x
    index.list[[ind.i]]$fbgeo.monthly = aggregate(fbgeo[(initmd+2):(endpd-startpd+1)],by=list(month.id),mean)$x
    index.list[[ind.i]]$tornqvist.monthly = aggregate(tornqvist[(initmd+2):(endpd-startpd+1)],by=list(month.id),mean)$x
    index.list[[ind.i]]$coli.monthly = coli.agg$x
  }
  index.list[[ind.i]]$coli.index.types = coli.index.types
  index.list[[ind.i]]$laspbytype = laspbytype
  for(j in 1:4) {
    for(k in 1:2) {
      index.list[[ind.i]]$bpbytype[[j+4*(k-1)]] = bpbytype[[j+4*(k-1)]][startpd:endpd]
      index.list[[ind.i]]$bpbytype.coli[[j+4*(k-1)]] = bpbytype.coli[[j+4*(k-1)]][startpd:endpd]
    }
  }
  index.list[[ind.i]]$coli.fs1.bytype = coli.fs1.bytype

}

# run regressions of indexes on time trends

res.i = vector("list",length=13)
loess.i = vector("list",length=13)

do.ind = 1

for(ind.i in do.ind) {

  if(ind.i < 3) {
    startpd = 22
  } else {
    startpd = 73
  }

  tt1 = 1:(endpd-startpd+1)
  minprice = apply(price2[startpd:endpd,,],1,min,na.rm=TRUE)

  res.i[[1]] = lm(index.list[[ind.i]]$laspeyres~tt1)
  res.i[[2]] = lm(index.list[[ind.i]]$tornqvist~tt1)
  res.i[[3]] = lm(index.list[[ind.i]]$fisher~tt1)
  res.i[[4]] = lm(index.list[[ind.i]]$coli.index~tt1)
  res.i[[5]] = lm(index.list[[ind.i]]$coli.index.types[[1]]~tt1)
  res.i[[6]] = lm(index.list[[ind.i]]$coli.index.types[[2]]~tt1)
  tt2 = 1:length(index.list[[ind.i]]$coli.fs1)
  res.i[[7]] = lm(index.list[[ind.i]]$coli.fs1~tt2)
  res.i[[8]] = lm(minprice/minprice[1]~tt1)
  res.i[[9]] = lm(index.list[[4]]$coli.index~tt1)
  res.i[[10]] = lm(index.list[[4]]$coli.index.types[[2]]~tt1)
  res.i[[11]] = lm(index.list[[ind.i]]$bestprice[[1]]~tt1)
  res.i[[12]] = lm(index.list[[4]]$bpbytype[[8]]~tt1)
  res.i[[13]] = lm(index.list[[4]]$coli.index.types[[1]]~tt1)

  loess.i[[1]] = loess(index.list[[ind.i]]$laspeyres~tt1)
  loess.i[[2]] = loess(index.list[[ind.i]]$tornqvist~tt1)
  loess.i[[3]] = loess(index.list[[ind.i]]$fisher~tt1)
  loess.i[[4]] = loess(index.list[[ind.i]]$coli.index~tt1)
  loess.i[[5]] = loess(index.list[[ind.i]]$coli.index.types[[1]]~tt1)
  loess.i[[6]] = loess(index.list[[ind.i]]$coli.index.types[[2]]~tt1)
  tt2 = 1:length(index.list[[ind.i]]$coli.fs1)
  loess.i[[7]] = loess(index.list[[4]]$coli.fs1~tt2)
  loess.i[[8]] = loess(minprice/minprice[1]~tt1)
  loess.i[[9]] = loess(index.list[[4]]$coli.index~tt1)
  loess.i[[10]] = loess(index.list[[4]]$coli.index.types[[2]]~tt1)
  loess.i[[11]] = loess(index.list[[ind.i]]$bestprice[[1]]~tt1)
  loess.i[[12]] = loess(index.list[[4]]$bpbytype[[6]]~tt1)
  loess.i[[13]] = loess(index.list[[4]]$coli.index.types[[1]]~tt1)

  loess.i[[14]] = loess(index.list[[4]]$fs1.coli~tt2)
  loess.i[[15]] = loess(index.list[[4]]$mean.coli~tt1)

  for(j in 1:length(res.i)) {
    print(summary(res.i[[j]]))
  }

}

# make a table showing indexes before and after the price regime change
# break occurs in period 85 (erim week 198707)

# results cast as price indexes (older version)

breakpd = which(allweek==198707)-startpd
totpd = endpd-startpd+1

sigfig = 2

ind.table = c("Laspeyres (Weekly)","T\\\"{o}rnqvist (Weekly)","Fisher (Weekly)","Best Price (Weekly)","Unit Value (Weekly)","Dynamic Model Index (Weekly)","Dynamic (High Cost, Weekly)", "Dynamic (Low Cost, Weekly)","%Laspeyres (Monthly)","%Feenstra and Shapiro (2003) Index (Monthly)","%Best Price (Monthly)","%Dynamic Index (Monthly)","%Dynamic (Low Cost, Monthly)",
              "Laspeyres (Bi-Monthly)","Unit Value (Bi-Monthly)","Feenstra and Shapiro (2003) Index (Bi-Monthly)","Best Price (Bi-Monthly)","Dynamic Index (Bi-Monthly)","Dynamic (Low Cost,Bi-Monthly)")

ind.i = c(rep(1,8),2,1,2,2,2,4,4,4,4,4,4)
colitype = c(1,1,1,1,1,1,1,2,1,1,1,1,2,1,1,1,1,1,2)
ind.names = c("laspeyres","tornqvist","fisher","bestprice","unitvalue","coli.index","coli.index.types","coli.index.types","laspeyres","coli.fs1","bestprice","coli.index","coli.index.types",
              "laspeyres","unitvalue","coli.fs1","bestprice","coli.index","coli.index.types")

for(i in 1:length(ind.names)) {
  n = ind.names[i]
  if(n=="coli.index.types" | n=="bestprice") {
    ind.table[i] = paste(ind.table[i]," & ",round(100*mean(index.list[[ind.i[i]]][[n]][[colitype[i]]][1:(breakpd-1)]),sigfig)," & ",round(100*mean(index.list[[ind.i[i]]][[n]][[colitype[i]]][breakpd:totpd]),sigfig)," & ",-(round(100*mean(index.list[[ind.i[i]]][[n]][[colitype[i]]][1:(breakpd-1)])-100*mean(index.list[[ind.i[i]]][[n]][[colitype[i]]][breakpd:totpd]),sigfig))," \\\\",sep="")
  } else {
    ind.table[i] = paste(ind.table[i]," & ",round(100*mean(index.list[[ind.i[i]]][[n]][1:(breakpd-1)]),sigfig)," & ",round(100*mean(index.list[[ind.i[i]]][[n]][breakpd:totpd]),sigfig)," & ",-(round(100*mean(index.list[[ind.i[i]]][[n]][1:(breakpd-1)])-100*mean(index.list[[ind.i[i]]][[n]][breakpd:totpd]),sigfig))," \\\\",sep="")
  }
}

ind.table = c(ind.table[1:8],"%\\hline",ind.table[9:13],"\\hline",ind.table[14:19])

write.table(ind.table,file=paste(tablepath,"indexes_tuna.tex",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE,sep="")

# Results expressed as COLI (current version)

ind.tab.c = c("Laspeyres (Weekly)","T\\\"{o}rnqvist (Weekly)","Fisher (Weekly)","Best Price (Weekly)","Unit Value (Weekly)","Dynamic Model Index (Weekly)","Dynamic (High Cost, Weekly)", "Dynamic (Low Cost, Weekly)",
              "Laspeyres (Bi-Monthly)","Unit Value (Bi-Monthly)","Feenstra and Shapiro (2003) Index (Bi-Monthly)","Best Price (Bi-Monthly)","Dynamic Index (Bi-Monthly)","Dynamic (Low Cost,Bi-Monthly)","CK (Weighted Average)",
              "Average of CK (Weighted Avg), FS")

ind.i.c = c(rep(1,8),4,4,4,4,4,4,4,4)
colitype.c = c(1,1,1,1,1,1,1,2,1,1,1,1,1,2,1,1)
ind.names.c = c("l.coli","t.coli","fisher.coli","bestprice.coli","unitvalue.coli","mean.coli","mcoli.type","mcoli.type",
"l.coli","unitvalue.coli","fs1.coli","bestprice.coli","mean.coli","mcoli.type","ck.coli","avg.coli")

for(i in 1:length(ind.names.c)) {
  n = ind.names.c[i]
  if(n=="mcoli.type" | n=="bestprice.coli" | n == "ck.coli" | n == "avg.coli") {
    ind.tab.c[i] = paste(ind.tab.c[i]," & ",round(100*mean(index.list[[ind.i.c[i]]][[n]][[colitype.c[i]]][1:(breakpd-1)]),sigfig)," & ",round(100*mean(index.list[[ind.i.c[i]]][[n]][[colitype.c[i]]][breakpd:totpd]),sigfig)," & ",-(round(100*mean(index.list[[ind.i.c[i]]][[n]][[colitype.c[i]]][1:(breakpd-1)])-100*mean(index.list[[ind.i.c[i]]][[n]][[colitype.c[i]]][breakpd:totpd]),sigfig))," \\\\",sep="")
  } else {
    ind.tab.c[i] = paste(ind.tab.c[i]," & ",round(100*mean(index.list[[ind.i.c[i]]][[n]][1:(breakpd-1)]),sigfig)," & ",round(100*mean(index.list[[ind.i.c[i]]][[n]][breakpd:totpd]),sigfig)," & ",-(round(100*mean(index.list[[ind.i.c[i]]][[n]][1:(breakpd-1)])-100*mean(index.list[[ind.i.c[i]]][[n]][breakpd:totpd]),sigfig))," \\\\",sep="")
  }
}

oo = 1:length(ind.tab.c)
oo[10] = 12
oo[11] = 10
oo[12] = 15
oo[13] = 11
oo[14] = 13
oo[15] = 14

ind.tab.c = ind.tab.c[oo]

ind.tab.c = c(ind.tab.c[1:8],"\\hline",ind.tab.c[9:15],"\\hline",ind.tab.c[16:16])

write.table(ind.tab.c,file=paste(tablepath,"indexes_tuna_coli.tex",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE,sep="")

# yearly aggregates of monthly indexes

ind.tab.y = c("Laspeyres","FS","CK","Dynamic Model")

ind.i.y = c(2,4,4,4)
colitype.y = c(1,1,1,1)
ind.names.y = c("l.coli","fs1.coli","ck.coli","mean.coli")

splitpd = 52

for(i in 1:length(ind.names.y)) {
  n = ind.names.y[i]
  if(n=="mcoli.type" | n=="bestprice.coli" | n == "ck.coli" | n == "avg.coli") {
    ind.tab.y[i] = paste(ind.tab.y[i]," & ",round(100*mean(index.list[[ind.i.y[i]]][[n]][[colitype.y[i]]][1:(splitpd-1)]),sigfig)," & ",round(100*mean(index.list[[ind.i.y[i]]][[n]][[colitype.y[i]]][splitpd:totpd]),sigfig)," & ",-(round(100*mean(index.list[[ind.i.y[i]]][[n]][[colitype.y[i]]][1:(splitpd-1)])-100*mean(index.list[[ind.i.y[i]]][[n]][[colitype.y[i]]][splitpd:totpd]),sigfig))," \\\\",sep="")
  } else {
    ind.tab.y[i] = paste(ind.tab.y[i]," & ",round(100*mean(index.list[[ind.i.y[i]]][[n]][1:(splitpd-1)]),sigfig)," & ",round(100*mean(index.list[[ind.i.y[i]]][[n]][splitpd:totpd]),sigfig)," & ",-(round(100*mean(index.list[[ind.i.y[i]]][[n]][1:(splitpd-1)])-100*mean(index.list[[ind.i.y[i]]][[n]][splitpd:totpd]),sigfig))," \\\\",sep="")
  }
}

write.table(ind.tab.y,file=paste(tablepath,"indexes_tuna_yearly.tex",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE,sep="")


# before-after comparison for FS index with a wider window

ii1 = 100*mean(index.list[[3]][["fs1.coli"]][1:(breakpd-1)])
ii2 = 100*mean(index.list[[3]][["fs1.coli"]][breakpd:totpd])
cat("Wider window FS: ",ii1,", ",ii2,", ",ii2-ii1,".\n",sep="")

ii1 = 100*mean(index.list[[3]][["bestprice.coli"]][[1]][1:(breakpd-1)])
ii2 = 100*mean(index.list[[3]][["bestprice.coli"]][[1]][breakpd:97])
cat("Wider window BestPrice: ",ii1,", ",ii2,", ",ii2-ii1,".\n",sep="")

ii1 = 100*mean(index.list[[3]][["ck.coli"]][[1]][1:(breakpd-1)])
ii2 = 100*mean(index.list[[3]][["ck.coli"]][[1]][breakpd:97])
cat("Wider window CK: ",ii1,", ",ii2,", ",ii2-ii1,".\n",sep="")

# compute confidence intervals on the indexes

for(i in c(1,2,4)) {
  cat("CIs for index list",i,"\n")
  meanind1 = apply(compsave2[[i]][,1:(breakpd-1)],1,mean)
  ci1 = quantile(meanind1,probs=c(0.025,0.975))
  meanind2 = apply(compsave2[[i]][,breakpd:totpd],1,mean)
  ci2 = quantile(meanind2,probs=c(0.025,0.975))
  cidif = quantile(meanind2-meanind1,probs=c(0.025,0.975))
  cat(paste("[",ci1[1],", ",ci1[2],"]; ",sep=""),paste(" [",ci2[1],", ",ci2[2],"]; ",sep=""),paste(" [",cidif[1],", ",cidif[2],"] \n",sep=""),sep="")
}

# make a table comparing all the best price indexes to the other indexes

ind.table2 = c("Dynamic Index (Monthly)","Dynamic (Low Cost, Monthly)","Best Price (Monthly, Fixed Weights, All Households)",
"Best Price (Monthly, Fixed Weights, Low Cost)","Best Price (Monthly, Varying Weights, Low Cost)",
"Dynamic Index (Bi-Monthly)","Dynamic (Low Cost, Bi-Monthly)","Best Price (Bi-Monthly, Fixed Weights, All Households)",
"Best Price (Bi-Monthly, Fixed Weights, Low Cost)","Best Price (Bi-Monthly, Varying Weights, Low Cost)")

ind.i = c(rep(2,5),rep(4,5))
colitype = rep(c(1,2,1,5,6),2)
ind.names = rep(c("mean.coli","mcoli.type","bestprice.coli","bpbytype.coli","bpbytype.coli"),2)

for(i in 1:length(ind.names)) {
  n = ind.names[i]
  if(n=="mcoli.type" | n=="bestprice.coli" | n=="bpbytype.coli") {
    ind.table2[i] = paste(ind.table2[i]," & ",round(100*mean(index.list[[ind.i[i]]][[n]][[colitype[i]]][1:(breakpd-1)]),sigfig)," & ",round(100*mean(index.list[[ind.i[i]]][[n]][[colitype[i]]][breakpd:totpd]),sigfig)," \\\\",sep="")
  } else {
    ind.table2[i] = paste(ind.table2[i]," & ",round(100*mean(index.list[[ind.i[i]]][[n]][1:(breakpd-1)]),sigfig)," & ",round(100*mean(index.list[[ind.i[i]]][[n]][breakpd:totpd]),sigfig)," \\\\",sep="")
  }
}

ind.table2 = c(ind.table2[1:5],"\\hline",ind.table2[6:10])

write.table(ind.table2,file=paste(tablepath,"indexes_comparison_tuna.tex",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE,sep="")


minv.type = vector("list",length=2)
mcons.type = vector("list",length=2)
for(n in 1:2) {

  minv.type[[n]] = apply(isaves.types[seq(nstart,nend,nskip),startpd:endpd+(n-1)*endpd],2,mean)

  mcons.type[[n]] = apply(csaves.types[seq(nstart,nend,nskip),startpd:endpd+(n-1)*endpd],2,mean)

}

# calculation of deal frequencies, spreads, etc, for the store data sample

product = "tuna"

load(paste(step1path,"weeklyprices_",product,".RData",sep=""))

alldate = unique(pf1w$WEEK)
alldate = alldate[order(alldate)]

# graph for the data section

dlabs = alldate[16:138]
dlaxis = dlabs[seq(1,endpd,13)]
dllabs = format(dlaxis,"%Y-%m")

# look at the spread between indexes over time

spread = vector("list",length=3)

st1 = 1

spread[[1]] = modeminspread.big[[4]][[1]][st1:endpd]
spread[[2]] = meanminspread.big[[4]][[1]][st1:endpd]
spread[[3]] = maxminspread.big[[4]][[1]][st1:endpd]

spreadtab1 = c("Mode - Min", "Mean - Min", "Max - Min")
for(i in 1:3) {
  spreadtab1[i] = paste(spreadtab1[i],
            " & ",round(mean(spread[[i]][1:(breakpd-st1)]),sigfig),
            " & ",round(mean(spread[[i]][(breakpd-st1+1):(endpd-st1+1)]),sigfig),
            " & ",round(quantile(spread[[i]][1:(breakpd-st1)],probs=c(0.5)),sigfig),
            " & ",round(quantile(spread[[i]][(breakpd-st1+1):(endpd-st1)],probs=c(0.5)),sigfig),
            " \\\\",sep="")
}

write.table(spreadtab1,file=paste(tablepath,"spreadtabletuna.tex",sep=""),
            quote=FALSE,row.names=FALSE,col.names=FALSE)

# spread between deal and nondeal price plus frequencies

temp1 = regprice.big[[4]]
temp2 = dealprice.big[[4]]
temp2[temp2==0] = NA

spreadtab2 = c("Regular Price","Deal Price","Reg-Deal Spread","Deal Frequency")

spread[[1]] = regprice.big[[4]]
spread[[2]] = dealprice.big[[4]]
spread[[3]] = dealspread.big[[4]]
spread[[4]] = dealfreq.big[[4]]

spread[[2]][spread[[2]]==0] = NA
spread[[3]][spread[[3]]==0] = NA

for(i in 1:4) {
  spreadtab2[i] = paste(spreadtab2[i],
            " & ",round(mean(spread[[i]][1:breakpd],na.rm=TRUE),sigfig),
            " & ",round(mean(spread[[i]][(breakpd+1):endpd],na.rm=TRUE),sigfig)," \\\\",sep="")
}

write.table(spreadtab2,file=paste(tablepath,"dealregtuna.tex",sep=""),
            quote=FALSE,row.names=FALSE,col.names=FALSE)

# medians

spreadtab3 = c("Regular Price","Deal Price","Reg-Deal Spread","Deal Frequency")

for(i in 1:4) {
  spreadtab3[i] = paste(spreadtab3[i],
            " & ",round(quantile(spread[[i]][1:breakpd],probs=0.5,na.rm=TRUE),sigfig),
            " & ",round(quantile(spread[[i]][(breakpd+1):endpd],probs=0.5,na.rm=TRUE),sigfig)," \\\\",sep="")
}

cat("Ratio of inclusive value to utility: ", mean(abs(mean.iv[startpd:endpd])/mean.util),"\n")
cat("Ratio of inclusive value utility to utility: ", mean(abs(mean.ivutil[startpd:endpd])/mean.util),"\n")
cat("Ratio of inclusive value utility to consumption utility: ", mean(abs(mean.ivutil[startpd:endpd])/abs(mean.util-mean.ivutil[startpd:endpd])),"\n")

# fraction bought off/on deal
dealflag = prices < (1-dealpct)*pmax(rprices,prices)
q1 = quants[startpd-1+1:breakpd,,]
d1 = dealflag[startpd-1+1:breakpd,,]
q2 = quants[(startpd+breakpd):endpd,,]
d2 = dealflag[(startpd+breakpd):endpd,,]
cat("Pre break fraction bought on deal: ",sum(q1[d1])/sum(q1),"\n")
cat("Post break fraction bought on deal: ",sum(q2[d2])/sum(q2),"\n")

# regression of utility on laspeyres, best price index - gives us the CK weights

res.indx1 = lm(index.list[[4]]$coli.index~index.list[[4]]$laspeyres+index.list[[4]]$bpbytype[[2]]-1)

res.indx2 = lm(index.list[[4]]$coli.index~index.list[[4]]$laspeyres+index.list[[4]]$bestprice[[1]]-1)

res.indx3 = lm(index.list[[4]]$coli.index~index.list[[4]]$laspeyres+index.list[[4]]$bestprice[[1]]+index.list[[4]]$coli.fs1[1:totpd]-1)

cat("Appendix Table Regression with Index Weights\n")
print(summary(res.indx2))

indx.new1 = res.indx1$coefficients[1]*index.list[[4]]$laspeyres+res.indx1$coefficients[2]*index.list[[4]]$bestprice[[1]]
indx.new2 = res.indx2$coefficients[1]*index.list[[4]]$laspeyres+res.indx2$coefficients[2]*index.list[[4]]$bpbytype[[2]]

indx.new1.loess = loess(indx.new1~tt1)
indx.new2.loess = loess(indx.new2~tt1)


pdf(paste(figpath,"tuna_data_indexes.pdf",sep=""))
matplot(dlabs,cbind(laspeyres.big[[1]]/laspeyres.big[[1]][1],bestprice.big[[4]][[1]]/bestprice.big[[4]][[1]][1]),type="l",main="Canned Tuna Laspeyres and BiMonthly Best Price Indexes",xlab="Week",ylab="Index",xaxt="n")
axis(1,at=dlaxis,labels=dllabs)
legend("topright",c("Laspeyres","Best Price"),col=1:2,lty=1:2,inset=0.01)
dev.off()

# check monthly averages

week2month = as.integer(0:(totpd-1)/4+1)

cindx = aggregate(index.list[[2]]$coli.index,by=list(week2month),FUN=mean)[,2]
cindx1 = aggregate(index.list[[2]]$coli.index.types[[1]],by=list(week2month),FUN=mean)[,2]
cindx2 = aggregate(index.list[[2]]$coli.index.types[[2]],by=list(week2month),FUN=mean)[,2]
lindx = aggregate(index.list[[2]]$laspeyres,by=list(week2month),FUN=mean)[,2]
bindx = aggregate(index.list[[2]]$bestprice[[1]],by=list(week2month),FUN=mean)[,2]
fsindx = index.list[[2]]$coli.fs
findx = aggregate(index.list[[2]]$fisher,by=list(week2month),FUN=mean)[,2]

# Best Price vs Monthly Dynamic COLI for Stockpilers

indx.new1 = res.indx1$coefficients[1]*index.list[[4]]$laspeyres+res.indx1$coefficients[2]*index.list[[4]]$bestprice[[1]]
indx.new2 = res.indx2$coefficients[1]*index.list[[4]]$laspeyres+res.indx2$coefficients[2]*index.list[[4]]$bpbytype[[2]]

indx.new1.loess = loess(indx.new1~tt1)
indx.new2.loess = loess(indx.new2~tt1)

pdf(paste(figpath,"indexplot_tuna.pdf",sep=""))
matplot(cbind(indx.new1,indx.new1.loess$fitted,index.list[[4]]$coli.index,loess.i[[9]]$fitted),type="l",col=c("black","black","red","red"),lty=c(1,1,2,2),lwd=c(1,2,1,2),xlab="Week",ylab="Index",main="Approximate and Dynamic Indexes for Canned Tuna")
legend("bottomleft",c("Approximate Index","Local Linear Trend","Dynamic Index","Local Linear Trend"),col=c("black","black","red","red"),lty=c(1,1,2,2),lwd=c(1,2,1,2),inset=0.01)
dev.off()

save(res.indx1,res.indx2,res.indx3,file=paste(estpath,"indxregressions_tuna.RData",sep=""))


# create plots of simulated inventories

stockpiler = meantype > 0.5

frac.util.types = mean(stockpiler)*mean.util.types[endpd+1:endpd]/(mean(stockpiler)*mean.util.types[endpd+1:endpd]+(1-mean(stockpiler))*mean.util.types[1:endpd])

cat("average fraction of utility to stockpilers:",mean(frac.util.types),"\n")

cat("avg aggregate inventory cost:",mean(minv.type[[1]]*minv.type[[1]]*0.177/1.233),"\n")

pdf(paste(figpath,"tuna_inventory_simulated.pdf",sep=""))

par(mfrow = c(2,1))

matplot(cbind(minv.type[[1]]*sum(!stockpiler),minv.type[[2]]*sum(stockpiler)),type="l",
        ylab="Cans",main="Simulated Inventory of Canned Tuna by Consumer Type")
legend("topleft",c("High Cost","Low Cost"),col=1:2,lty=1:2,inset = 0.02)

plot(minpricestore[startpd:endpd,11],type="l",
        ylab = "Cents",xlab="Week",main="Minimum Price Per Can For Representative Store (Tuna)")

dev.off()

par(mfrow = c(1,1))

cat("Average inventory ratio:",mean(minv.type[[2]])/mean(minv.type[[1]]),"\n")
cat("Population inventory ratio:",mean(sum(stockpiler)*minv.type[[2]])/mean(sum(!stockpiler)*minv.type[[1]]),"\n")

