ndraws = 10000
nfaccept = 50
nprint = 100

rho = c(sqrt(0.05),0.1)

bdraws = array(0,c(nhhs,length(out$par),ndraws))

xx = rep(0,length(fx))
xx[!fx] = out$par

b0 = matrix(xx,nrow=length(hhids),ncol=length(fx),byrow=TRUE)

zerovar = rep(FALSE,length(fx))
zerovar[2] = TRUE
zerovar[fx] = TRUE

b = out$par[!zerovar[!fx]]
b1 = b0
W = diag(sum(!zerovar))
S0 = W
v0 = 10

pastfaccept = rep(FALSE,nfaccept)

set.seed(82531952)

ll.brand.hh <- function(x1,hhbrand,hhids) {

  prices = hhbrand[,3+1:length(upckeep)]
  feat = hhbrand[,3+length(upckeep)+1:length(upckeep)]
  display = hhbrand[,3+2*length(upckeep)+1:length(upckeep)]

  b = data.frame(cbind(hhids,x1))
  colnames(b) = c("hhid",paste("b",1:length(upckeep),sep=""),"pcoeff",
                  "fcoeff","dcoeff")

  temp = merge(hhbrand,b,all.x=TRUE)
  temp = temp[order(temp$hhid,temp$week),]

  u = temp[,paste("b",1:length(upckeep),sep="")] - temp$pcoeff*prices +
      temp$fcoeff*feat + temp$dcoeff*display

  eu = exp(u)
  eu[prices==0] = 0
  denom = apply(eu,1,sum)

  cprob = eu[cbind(1:nrow(hhbrand),hhbrand$chosenb)]/denom

  hhprob = aggregate(log(cprob),by=list(temp$hhid),FUN=sum)
  colnames(hhprob) = c("hhid","ll")

  return(hhprob)

}


for(n in 1:ndraws) {

  # fixed draws

  b1 = b0
  b1[,zerovar & !fx] = b0[,zerovar & !fx]+sqrt(rho[1])*matrix(rnorm(sum(zerovar[!fx])),nrow=nhhs,ncol=sum(zerovar[!fx]),byrow=TRUE)
  ll0 = sum(ll.brand.hh(b0,hhbrand2,hhids)$ll)
  ll1 = sum(ll.brand.hh(b1,hhbrand2,hhids)$ll)
  r = exp(ll1-ll0)
  if(runif(1) < r) {
    pastfaccept[n%%nfaccept+1] = TRUE
    b0 = b1
  } else {
    pastfaccept[n%%nfaccept+1] = FALSE
  }
  if(n%%nfaccept == 0) {
    if(mean(pastfaccept) > 0.3) {
      rho[1] = rho[1] + rho[1]*0.1
    } else {
      rho[1] = rho[1] - rho[1]*0.1
    }
  }

  eps = matrix(rnorm(nhhs*sum(!zerovar)),nrow=nhhs,ncol=sum(!zerovar))
  b1[,!zerovar] = b0[,!zerovar] + sqrt(rho[2])*eps%*%chol(W)
  Wi = chol2inv(chol(W))
  ll0 = ll.brand.hh(b0,hhbrand2,hhids)$ll
  ll1 = ll.brand.hh(b1,hhbrand2,hhids)$ll
  bbig = matrix(b,nrow=nhhs,ncol=sum(!zerovar),byrow=TRUE)
  bdiff0 = t(b0[,!zerovar] - bbig)
  bdiff1 = t(b1[,!zerovar] - bbig)
  phi0 = t(colSums(bdiff0*(Wi%*%bdiff0)))
  phi1 = t(colSums(bdiff1*(Wi%*%bdiff1)))
  r = exp(ll1 - ll0 - 0.5*phi1 +0.5*phi0)

  u = runif(nhhs)
  acceptdraw = u < r & b0[,length(upckeep)+1] >= 0
  b0[acceptdraw,!zerovar] = b1[acceptdraw,!zerovar]

  if(mean(acceptdraw) > 0.3) {
    rho[2] = rho[2] + rho[2]*0.1
  } else {
    rho[2] = rho[2] - rho[2]*0.1
  }

  betamean = apply(b0[,!zerovar],2,mean)
  b = betamean + matrix(rnorm(sum(!zerovar)),nrow=1,ncol=sum(!zerovar))%*%chol(W)/sqrt(nhhs)
  bbig = matrix(b,nrow=nhhs,ncol=sum(!zerovar),byrow=TRUE)

  bb = b0[,!zerovar] - bbig
  S = t(bb)%*%bb + v0*S0
  XX = t(chol(solve(S)))%*%matrix(rnorm(sum(!zerovar)*(v0+nhhs)),nrow=sum(!zerovar),ncol=v0+nhhs)
  W = solve(XX%*%t(XX))

  bdraws[,,n] = b0[,!fx]

  if(n%%nprint==0) {
    cat("Information for iteration ",n,"\n")
    bb = rep(0,length(fx))
    bb[zerovar] = b0[1,zerovar]
    bb[!zerovar] = b
    cat("b draws",bb,"\n")
    cat("W\n")
    print(W)
    cat("rho",rho,"\n")
    cat("pct draws acceptance",mean(acceptdraw),mean(pastfaccept),"\n")
  }

}

getiv.hh <- function(bdraws,hhbrand,hhids,burnin,fx,skip=10,nprint=1000) {

  prices = hhbrand[,3+1:length(upckeep)]
  feat = hhbrand[,3+length(upckeep)+1:length(upckeep)]
  display = hhbrand[,3+2*length(upckeep)+1:length(upckeep)]

  ndraws = dim(bdraws)[3]

  for(i in seq(burnin,ndraws,skip)) {

    b = data.frame(cbind(hhids,matrix(0,nrow=nhhs,ncol=length(fx))))
    b[,c(FALSE,!fx)] = bdraws[,,i]
    colnames(b) = c("hhid",paste("b",1:length(upckeep),sep=""),"pcoeff",
                    "fcoeff","dcoeff")

    temp = merge(hhbrand,b,all.x=TRUE)
    temp = temp[order(temp$hhid,temp$week),]

    u = temp[,paste("b",1:length(upckeep),sep="")] - temp$pcoeff*prices +
        temp$fcoeff*feat + temp$dcoeff*display

    eu = exp(u)
    eu[prices==0] = 0
    denom = log(apply(eu,1,sum))

    if(i == burnin) {
      ivout = data.frame(cbind(hhbrand$hhid,hhbrand$week,rep(i-burnin+1,nrow(hhbrand)),denom))
      colnames(ivout) = c("hhid","week","rep","iv")
    } else {
      iv1 = data.frame(cbind(hhbrand$hhid,hhbrand$week,rep(i-burnin+1,nrow(hhbrand)),denom))
      colnames(iv1) = c("hhid","week","rep","iv")
      ivout = rbind(ivout,iv1)
    }

    if(i%%nprint==0) {
      cat("Finished computing for draw",i,"\n")
    }

  }

  return(ivout)

}

save(bdraws,file=paste(outputpath,"bdrawsave_tuna.RData",sep=""))

ivout = getiv.hh(bdraws,hhbrand2,hhids,2000,fx)

ivmeanhh = aggregate(ivout$iv,by=list(ivout$hhid),FUN=mean)
ivsdhh = aggregate(ivout$iv,by=list(ivout$hhid),FUN=sd)

